//Pro tip: prefs are displayed opposite the order in which they're registered.

new scriptGroup(Slayer_GameModeTemplateSG)
{
	className = "GunGame";
	uiName = "Gun Game";
	useTeams = false;
	disable_teamCreation = 1;

		//Basic Options - Default
	default_title = "Gun Game";
	default_colorIdx = 45;
	default_inviteOnly = 0;
	default_isDefaultMiniGame = 1;
	default_playersUseOwnBricks = 0;
	default_useAllPlayersBricks = 0;
	default_fallingDamage = 1;
	default_selfDamage = 1;
	default_brickDamage = 0;
	default_botDamage = 1;
	default_vehicleDamage = 0;
	default_time = 10;
	default_nameDistance = 500;
	default_enablePlayerLights = 1;
	default_enablePlayerSuicide = 0;
	default_respawnTime_player = 7;
	default_respawnTime_bot = 15;
	default_respawnTime_vehicle = 30;
	default_respawnTime_brick = 15;

		//Advanced Options - Default
	default_CPTransitionalColors = 1;
	default_chat_deadChatMode = 2;
	default_flyCam_playDuringCountdown = 0;
	default_flyCam_playOnReset = 0;
	default_flyCam_roundsBetweenFlyThroughs = 1;
	default_flyCam_roundsPassed = 0;
	default_allowMoveWhileResetting = 0;
	default_preRoundSeconds = 5;
	default_resetOnEmpty = 0;
	default_spawnBrickColor = -1;
	default_timeBetweenRounds = 5;
	default_editRights = 4;
	default_leaveRights = 5;
	default_resetRights = 4;
	default_spectateAutoCam = 1;
	default_spectateCapturePoints = 0;

		//Basic Options - Locked
	locked_useSpawnBricks = 1;
	locked_enableBuilding = 0;
	locked_enablePainting = 0;
	locked_enableWand = 0;
	locked_weaponDamage = 1;
	locked_lives = 0;
	locked_points = 0;
	locked_startEquip0 = 0;
	locked_startEquip1 = 0;
	locked_startEquip2 = 0;
	locked_startEquip3 = " ";
	locked_startEquip4 = " ";
	locked_playerDataBlock = nameToID("GunGamePlayer");
	locked_points_killPlayer = 10;
	locked_points_killBot = 0;
	locked_points_die = 0;
	locked_points_killSelf = 0;
	locked_points_plantBrick = 0;
	locked_points_breakBrick = 0;

		//Advanced Options - Locked
	locked_bKills_pointsKillSpree = 0;
	locked_bKills_pointsMultiKill = 0;
	locked_bKills_enable = 0;
	locked_bKills_kSpree = 3;
	locked_chat_enableTeamChat = 0;
	locked_chat_teamDisplayMode = 0;
	locked_customRule = "<color:ffff00>Last kill<color:ff00ff> - Be the first to advance to the last weapon and kill someone with it.";
	locked_eorrEnable = 1;
	locked_eorrDisplayTeamScore = 0;
	locked_eorrDisplayVictory = 1;
	locked_clearScores = 1;
	locked_clearStats = 1;
	locked_lateJoinTime = -1;

	default_disableSlayerMessages = 0;
};

new scriptObject(Slayer_PrefSO : Slayer_DefaultPrefSO)
{
	category = "Game Mode";
	title = "Mix Levels Every Round";
	defaultValue = 0;
	permissionLevel = $Slayer::PermissionLevel["Host"];
	variable = "%mini.gunGameMixLevels";
	type = "list";
	list_items = "0 Disabled" NL "1 Enabled - Random" NL "2 Enabled - Shuffle";
	callback = "";
	notifyPlayersOnChange = true;
	guiTag = "Rules GunGame Mode";
};

new scriptObject(Slayer_PrefSO : Slayer_DefaultPrefSO)
{
	category = "Game Mode";
	title = "Mix Demote Every Round";
	defaultValue = 0;
	permissionLevel = $Slayer::PermissionLevel["Host"];
	variable = "%mini.gunGameMixDemote";
	type = "list";
	list_items = "0 Disabled" NL "1 Enabled - Melee Preferred" NL "2 Enabled - Any";
	callback = "";
	notifyPlayersOnChange = true;
	guiTag = "Rules GunGame Mode";
};

new scriptObject(Slayer_PrefSO : Slayer_DefaultPrefSO)
{
	category = "Game Mode";
	title = "Levels";
	defaultValue = 20;
	permissionLevel = $Slayer::PermissionLevel["Host"];
	variable = "%mini.gunGameNumLevels";
	type = "int";
	int_minValue = 1;
	int_maxValue = 500;
	callback = "gunGame_setNumLevels(%1, %mini, %2, true);";
	notifyPlayersOnChange = true;
	guiTag = "Rules GunGame Mode";
}; //Pref requires server restart if number is increased from number at server start and if the number is over 20.

exec("./slayerLevelPrefs.cs");

new scriptObject(Slayer_PrefSO : Slayer_DefaultPrefSO)
{
	category = "Game Mode";
	title = "Demote Weapon";
	defaultValue = nameToID(swordItem);
	permissionLevel = $Slayer::PermissionLevel["Owner"];
	variable = "%mini.gunGameDemoteWep";
	type = "object";
	object_class = "ItemData";
	object_cannotBeNull = false;
	callback = "%mini.gunGame_updateEquipmentAll();";
	notifyPlayersOnChange = true;
	guiTag = "Rules GunGame Player";
};

function gunGame_setNumLevels(%num, %mini, %oldNum, %oldMatters)
{
	%num = mFloor(%num + 0.5);

	if(%num < 20)
	{
		%num = 20;
	}

	else if(%num > 20)
	{
		//We can't know who changed the pref, so we'll just send the message to all server staff in the minigame.

		for(%i = 0; %i < %mini.numMembers; %i++)
		{
			%client = %mini.member[%i];

			if(%client.isAdmin || %client.isSuperAdmin)
			{
				commandToClient(%client, 'messageBoxOk', "Announcement To Server Staff", "One of the server staff has changed the number of Gun Game levels in the minigame and a server restart is required for it to take affect.");
			}
		}
	}

	if(%oldMatters && (%num == %oldNum || %oldNum $= ""))
	{
		return;
	}

	%file = new fileObject();
	%file.openForWrite("Add-Ons/GameMode_Gun_Game/slayerLevelPrefs.cs");

	for(%i = %num - 1; %i >= 0; %i--)
	{
		%file.writeLine("new scriptObject(Slayer_PrefSO : Slayer_DefaultPrefSO)");
		%file.writeLine("{");
		%file.writeLine("\tcategory = \"Game Mode\";");
		%file.writeLine("\ttitle = \"Level" SPC %i @ "\";");
		%file.writeLine("\tdefaultValue = nameToID(gunItem);");
		%file.writeLine("\tpermissionLevel = $Slayer::PermissionLevel[\"Owner\"];");
		%file.writeLine("\tvariable = \"%mini.gunGameLevel" @ %i @ "\";");
		%file.writeLine("\ttype = \"object\";");
		%file.writeLine("\tobject_class = \"ItemData\";");
		%file.writeLine("\tobject_cannotBeNull = true;");
		%file.writeLine("\tcallback = \"%mini.gunGame_updateEquipmentAll();\";");
		%file.writeLine("\tnotifyPlayerOnChange = true;");
		%file.writeLine("\tguiTag = \"Rules GunGame Player\";");
		%file.writeLine("};");

		if(%i > 0)
		{
			%file.writeLine("");
		}
	}

	%file.delete();
}

function minigameSO::gunGame_updateEquipmentAll(%mini)
{
	for(%i = 0; %i < %mini.numMembers; %i++)
	{
		%mini.member[%i].updateGunGameEquipment(1);
	}
}