//List functions found in Event_Minigame
function addItemToList(%string, %item)
{
	if(hasItemOnList(%string, %item))
	{
		return %string;
	}

	if(%string $= "")
	{
		return %item;
	}

	else
	{
		return %string SPC %item;
	}
}

function hasItemOnList(%string, %item)
{
	for(%i = 0; %i < getWordCount(%string); %i++)
	{
		if(getWord(%string, %i) $= %item)
		{
			return 1;
		}
	}

	return 0;
}

function removeItemFromList(%string, %item)
{
	if(!hasItemOnList(%string, %item))
	{
		return %string;
	}

	for(%i = 0; %i < getWordCount(%string); %i++)
	{
		if(getWord(%string, %i) $= %item)
		{
			if(%i == 0)
			{
				return getWords(%string,1,getWordCount(%string));
			}

			else if(%i == getWordCount(%string) - 1)
			{
				return getWords(%string, 0, %i - 1);
			}

			else
			{
				return getWords(%string, 0, %i - 1) SPC getWords(%string, %i + 1, getWordCount(%string));
			}
		}
	}
}

function ItemData::isMelee(%data)
{
	if(!isObject(%image = %data.image) || %image.getClassName() !$= "ShapeBaseImageData")
	{
		return false;
	}

	return %image.isMelee();
}

function ShapeBaseImageData::isMelee(%data)
{
	if(!isObject(%proj = %data.projectile) || %proj.getClassName() !$= "ProjectileData")
	{
		return false;
	}

	if(%proj.armingDelay <= 0 && %proj.lifetime <= 175 && %proj.bounceElasticity <= 0 && %proj.bounceFriction <= 0 && %proj.gravityMod <= 0.25 && (%proj.directDamage || (isObject(%explo = %proj.explosion) && %explo.radiusDamage && %explo.damageRadius <= 10)))
	{
		return true;
	}

	return false;
}